﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.UI;

public class LevelManager : MonoBehaviour
{

    public int blockSize;
    public int numOfBlocks;
    public int scrollSpeed;
    public int distance;

    public Transform distcalc;

    public Text distTex;
    public Text finalTex;

    private LevelBlockFactory factory;
    private List<LevelBlock> levelBlocks;
    private Vector3 currentPos;

    // Use this for initialization
    void Start()
    {
        factory = new LevelBlockFactory();
        levelBlocks = new List<LevelBlock>();
        currentPos = new Vector3(-25, 0, 0);

        for (int i = 0; i < numOfBlocks; i++)
        {
            Vector3 pos = new Vector3(currentPos.x + (blockSize * i), 0, 5);

            if(i==0 || i==1)
            {

                LevelBlock bBlock = factory.CreateBlankLevelBlock(pos, blockSize);
                levelBlocks.Add(bBlock);
                continue;
            }

            LevelBlock lBlock = factory.CreateNewLevelBlock(pos, blockSize);
            levelBlocks.Add(lBlock);
        }
    }

    // Update is called once per frame
    void Update()
    {
        distcalc.Translate(Vector3.left * Time.deltaTime * scrollSpeed);
        distance = (int)Mathf.Floor(-distcalc.position.x);
        distTex.text = "Distance: " + distance;
        finalTex.text = "Distance: " + distance;
        MoveBlocks();
    }

    private void MoveBlocks()
    {
        bool delete = false;
        for (int i = 0; i < numOfBlocks; i++)
        {
            levelBlocks[i].MoveBlock(Vector3.left * Time.deltaTime * scrollSpeed);

            if (levelBlocks[i].getParent().transform.position.x <= -50 && delete == false)
            {
                delete = true;
            }

        }
        
        if (delete == true)
        {

            levelBlocks[0].Die();
            levelBlocks.RemoveAt(0);

            DeleteBlock();
            delete = false;
        }
    }

    private void DeleteBlock()
    {
        
        Vector3 pos = new Vector3(levelBlocks[numOfBlocks-2].getParent().transform.position.x + 25, 0, 5);
        
        LevelBlock lBlock = factory.CreateNewLevelBlock(pos, blockSize);
        
        levelBlocks.Add(lBlock);
    }
}
