﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class PlayerController : MonoBehaviour
{
    public GameObject deadLight;

    public UseEcho useecho;
	public AudioSource firefly;
	public AudioSource collideSound;
    public Text finalDist;
    public Text finalScore;
    public Text finalEcho;

    public float speed = 1;
    public int lives = 3;
    public Text livesText;
    public float invincibleTime = 3f;
    private bool invincible = false;
    public int score = 0;

    public GameObject endgamePanel;
    
    public Text scoreT;
    public Text distT;


    // Use this for initialization
    void Start()
    {
        livesText.text = "Lives: " + lives.ToString();
        scoreT.text = "Score: " + score.ToString();
		deadLight.SetActive(false);
    }

    // Update is called once per frame
    void Update()
    {
        if (Time.timeScale > 0)
        {
        }
        else
        {
            if(Input.GetButtonDown("Start"))
            {
                Application.LoadLevel(1);
            }

            if (Input.GetButtonDown("Cancel"))
            {
                Application.Quit();
            }
        }

        if(lives > 0)
        {
            Time.timeScale = 1;
        }
        
        var dist = (this.transform.position - Camera.main.transform.position).z;

        var leftBorder = Camera.main.ViewportToWorldPoint(new Vector3(0, 0, dist)).x;
        var rightBorder = Camera.main.ViewportToWorldPoint(new Vector3(1, 0, dist)).x;
        var topBorder = Camera.main.ViewportToWorldPoint(new Vector3(0, 0, dist)).y;
        var bottomBorder = Camera.main.ViewportToWorldPoint(new Vector3(0, 1, dist)).y;

        Vector3 playerSize = this.gameObject.GetComponent<BoxCollider>().bounds.size;

        this.transform.position = new Vector3(
            Mathf.Clamp(this.transform.position.x, leftBorder + playerSize.x / 2, rightBorder - playerSize.x / 2),
            Mathf.Clamp(this.transform.position.y, topBorder + playerSize.y / 2, bottomBorder - playerSize.y / 2),
            this.transform.position.z
        );


        float horizontal = Input.GetAxis("Horizontal");
        if(horizontal > 0)
        transform.Translate(Vector3.back * Time.deltaTime * horizontal * speed);

        if(horizontal < 0)
            transform.Translate(Vector3.back * Time.deltaTime * horizontal * speed *1.7f);


        float verical = Input.GetAxis("Vertical");
        transform.Translate(Vector3.up * Time.deltaTime * verical * speed * 1.5f);

        if (invincible && invincibleTime > 0)
        {
            invincibleTime -= Time.deltaTime;
            deadLight.SetActive(true);
            
        }
        else if (invincible && invincibleTime <= 0)
        {
            invincible = false;
            invincibleTime = 3f;
            deadLight.SetActive(false);
        }
    }

    public void loseLife()
    {
        lives -= 1;
        livesText.text = "Lives: " + lives.ToString();
		collideSound.Play ();

        if (lives > 0)
        {
            invincible = true;
        }
        else
        {
            gameOver();
        }

    }

    private void respawnPlayer()
    {
    }

    private void gameOver()
    {
        Time.timeScale = 0;
        endgamePanel.SetActive(true);
        finalEcho.text = "Echo used: " + useecho.totalused;
        finalScore.text = "Score: " + score.ToString();

        

    }

    void OnTriggerEnter(Collider collider)
    {
        if (!invincible && collider.gameObject.tag == "Obstacle")
        {
            
            loseLife();

        }


        if (collider.gameObject.tag == "Firefly")
        {
			if (collider.gameObject.name == "FireflyOrange(Clone)") {
				useecho.uses += 6;
				score += 60;
			}

			if (collider.gameObject.name == "FireflyPink(Clone)") {
				useecho.uses += 4;
				score += 40;
			}

			if (collider.gameObject.name == "FireflyYellow(Clone)") {
				useecho.uses += 2;
				score += 20;
			}

			firefly.Play();
			Destroy(collider.gameObject);
            scoreT.text = "Score: " + score.ToString();
        }
    }
}